Index: base/applications/rapps_new/gui.cpp
===================================================================
--- base/applications/rapps_new/gui.cpp	(Revision 68346)
+++ base/applications/rapps_new/gui.cpp	(Arbeitskopie)
@@ -611,7 +611,7 @@
         {
         case WM_CREATE:
             if (!InitControls())
-                PostMessage(hwnd, WM_CLOSE, 0, 0);
+                ::PostMessage(hwnd, WM_CLOSE, 0, 0);
             break;
 
         case WM_DESTROY:
@@ -729,8 +729,8 @@
                     }
                 }
 
-                HMENU mainMenu = GetMenu(hwnd);
-                HMENU lvwMenu = GetMenu(m_ListView->m_hWnd);
+                HMENU mainMenu = ::GetMenu(hwnd);
+                HMENU lvwMenu = ::GetMenu(m_ListView->m_hWnd);
 
                 /* Disable/enable items based on treeview selection */
                 if (IsSelectedNodeInstalled())
@@ -949,7 +949,7 @@
                 WCHAR szWndText[MAX_STR_LEN];
 
                 LoadStringW(hInst, IDS_SEARCH_TEXT, szBuf, _countof(szBuf));
-                GetWindowTextW(m_SearchBar->m_hWnd, szWndText, MAX_STR_LEN);
+                m_SearchBar->GetWindowTextW(szWndText, MAX_STR_LEN);
                 if (wcscmp(szBuf, szWndText) == 0)
                 {
                     SearchEnabled = FALSE;
@@ -960,7 +960,7 @@
 
             case EN_KILLFOCUS:
             {
-                GetWindowTextW(m_SearchBar->m_hWnd, szBuf, MAX_STR_LEN);
+                m_SearchBar->GetWindowTextW(szBuf, MAX_STR_LEN);
                 if (wcslen(szBuf) < 1)
                 {
                     LoadStringW(hInst, IDS_SEARCH_TEXT, szBuf, _countof(szBuf));
@@ -981,7 +981,7 @@
                 }
 
                 LoadStringW(hInst, IDS_SEARCH_TEXT, szBuf, _countof(szBuf));
-                GetWindowTextW(m_SearchBar->m_hWnd, szWndText, MAX_STR_LEN);
+                m_SearchBar->GetWindowTextW(szWndText, MAX_STR_LEN);
                 if (wcscmp(szBuf, szWndText) != 0)
                 {
                     StringCbCopy(szSearchPattern, sizeof(szSearchPattern),
@@ -1019,7 +1019,7 @@
             break;
 
         case ID_EXIT:
-            PostMessageW(m_hWnd, WM_CLOSE, 0, 0);
+            PostMessageW(WM_CLOSE, 0, 0);
             break;
 
         case ID_INSTALL:
@@ -1054,7 +1054,7 @@
             break;
 
         case ID_HELP:
-            MessageBoxW(m_hWnd, L"Help not implemented yet", NULL, MB_OK);
+            MessageBoxW(L"Help not implemented yet", NULL, MB_OK);
             break;
 
         case ID_ABOUT:
Index: base/applications/rapps_new/rosui.h
===================================================================
--- base/applications/rapps_new/rosui.h	(Revision 68346)
+++ base/applications/rapps_new/rosui.h	(Arbeitskopie)
@@ -668,7 +668,7 @@
 
         if (hDwp)
         {
-            return DeferWindowPos(hDwp, m_hWnd, NULL,
+            return DeferWindowPos(hDwp, NULL,
                 splitter.left, splitter.top,
                 splitter.right - splitter.left,
                 splitter.bottom - splitter.top,
Index: base/shell/explorer/taskswnd.cpp
===================================================================
--- base/shell/explorer/taskswnd.cpp	(Revision 68346)
+++ base/shell/explorer/taskswnd.cpp	(Arbeitskopie)
@@ -1235,9 +1235,9 @@
         if (::IsWindow(hWnd) && ::IsWindowVisible(hWnd) &&
             !m_Tray->IsSpecialHWND(hWnd))
         {
-            DWORD exStyle = GetWindowLong(hWnd, GWL_EXSTYLE);
+            DWORD exStyle = ::GetWindowLong(hWnd, GWL_EXSTYLE);
             /* Don't list popup windows and also no tool windows */
-            if ((GetWindow(hWnd, GW_OWNER) == NULL || exStyle & WS_EX_APPWINDOW) &&
+            if ((::GetWindow(hWnd, GW_OWNER) == NULL || exStyle & WS_EX_APPWINDOW) &&
                 !(exStyle & WS_EX_TOOLWINDOW))
             {
                 TRACE("Adding task for %p...\n", hWnd);
@@ -1404,7 +1404,7 @@
             break;
 
         case HSHELL_TASKMAN:
-            PostMessage(m_Tray->GetHWND(), TWM_OPENSTARTMENU, 0, 0);
+            ::PostMessage(m_Tray->GetHWND(), TWM_OPENSTARTMENU, 0, 0);
             break;
 
         case HSHELL_ACTIVATESHELLWINDOW:
@@ -1455,7 +1455,7 @@
 
         if (::IsWindow(TaskItem->hWnd))
         {
-            bIsMinimized = IsIconic(TaskItem->hWnd);
+            bIsMinimized = ::IsIconic(TaskItem->hWnd);
             bIsActive = (TaskItem == m_ActiveTaskItem);
 
             TRACE("Active TaskItem %p, selected TaskItem %p\n", m_ActiveTaskItem, TaskItem);
@@ -1467,7 +1467,7 @@
 
             if (!bIsMinimized && bIsActive)
             {
-                PostMessage(TaskItem->hWnd,
+                ::PostMessage(TaskItem->hWnd,
                     WM_SYSCOMMAND,
                     SC_MINIMIZE,
                     0);
@@ -1477,7 +1477,7 @@
             {
                 if (bIsMinimized)
                 {
-                    PostMessage(TaskItem->hWnd,
+                    ::PostMessage(TaskItem->hWnd,
                         WM_SYSCOMMAND,
                         SC_RESTORE,
                         0);
@@ -1524,7 +1524,7 @@
     VOID HandleTaskItemRightClick(IN OUT PTASK_ITEM TaskItem)
     {
 
-        HMENU hmenu = GetSystemMenu(TaskItem->hWnd, FALSE);
+        HMENU hmenu = ::GetSystemMenu(TaskItem->hWnd, FALSE);
 
         if (hmenu)
         {
@@ -1535,7 +1535,7 @@
             if (cmd)
             {
                 SetForegroundWindow(TaskItem->hWnd);    // reactivate window after the context menu has closed
-                PostMessage(TaskItem->hWnd, WM_SYSCOMMAND, cmd, 0);
+                ::PostMessage(TaskItem->hWnd, WM_SYSCOMMAND, cmd, 0);
             }
         }
     }
@@ -1790,7 +1790,7 @@
             RECT* prcMinRect = (RECT*) lParam;
             RECT rcItem, rcToolbar;
             m_TaskBar.GetItemRect(TaskItem->Index, &rcItem);
-            GetWindowRect(m_TaskBar.m_hWnd, &rcToolbar);
+            m_TaskBar.GetWindowRect(&rcToolbar);
 
             OffsetRect(&rcItem, rcToolbar.left, rcToolbar.top);
 
Index: base/shell/explorer/trayntfy.cpp
===================================================================
--- base/shell/explorer/trayntfy.cpp	(Revision 68346)
+++ base/shell/explorer/trayntfy.cpp	(Arbeitskopie)
@@ -291,10 +291,10 @@
         if (pid == GetCurrentProcessId() ||
             (uMsg >= WM_MOUSEFIRST && uMsg <= WM_MOUSELAST))
         {
-            PostMessage(notifyItem->hWnd,
-                        notifyItem->uCallbackMessage,
-                        notifyItem->uID,
-                        uMsg);
+            ::PostMessage(notifyItem->hWnd,
+                          notifyItem->uCallbackMessage,
+                          notifyItem->uID,
+                          uMsg);
         }
         else
         {
@@ -323,7 +323,7 @@
     LRESULT OnTooltipShow(INT uCode, LPNMHDR hdr, BOOL& bHandled)
     {
         RECT rcTip, rcItem;
-        GetWindowRect(hdr->hwndFrom, &rcTip);
+        ::GetWindowRect(hdr->hwndFrom, &rcTip);
 
         SIZE szTip = { rcTip.right - rcTip.left, rcTip.bottom - rcTip.top };
 
@@ -339,13 +339,13 @@
             if (hMon)
                 GetMonitorInfo(hMon, &monInfo);
             else
-                GetWindowRect(GetDesktopWindow(), &monInfo.rcMonitor);
+                ::GetWindowRect(GetDesktopWindow(), &monInfo.rcMonitor);
 
             GetItemRect(iBtn, &rcItem);
 
             POINT ptItem = { rcItem.left, rcItem.top };
             SIZE szItem = { rcItem.right - rcItem.left, rcItem.bottom - rcItem.top };
-            ClientToScreen(m_hWnd, &ptItem);
+            ClientToScreen(&ptItem);
 
             ptItem.x += szItem.cx / 2;
             ptItem.y -= szTip.cy;
@@ -436,10 +436,10 @@
         Toolbar.Initialize(m_hWnd);
 
         // Explicitly request running applications to re-register their systray icons
-        SendNotifyMessage(HWND_BROADCAST,
-                          RegisterWindowMessage(TEXT("TaskbarCreated")),
-                          0,
-                          0);
+        ::SendNotifyMessage(HWND_BROADCAST,
+                            RegisterWindowMessage(TEXT("TaskbarCreated")),
+                            0,
+                            0);
 
         return TRUE;
     }
@@ -732,7 +732,7 @@
         INT c, i;
         BOOL bRet = TRUE;
 
-        hDC = GetDC(m_hWnd);
+        hDC = GetDC();
         if (hDC != NULL)
         {
             if (hFont)
@@ -752,7 +752,7 @@
             if (hFont)
                 SelectObject(hDC, hPrevFont);
 
-            ReleaseDC(m_hWnd, hDC);
+            ReleaseDC(hDC);
 
             if (bRet)
             {
@@ -895,7 +895,7 @@
             CurrentSize = szWnd;
         }
 
-        if (IsWindowVisible(m_hWnd))
+        if (IsWindowVisible())
         {
             InvalidateRect(NULL, TRUE);
 
@@ -906,7 +906,7 @@
                 NMHDR nmh;
 
                 nmh.hwndFrom = m_hWnd;
-                nmh.idFrom = GetWindowLongPtr(m_hWnd, GWLP_ID);
+                nmh.idFrom = GetWindowLongPtr(GWLP_ID);
                 nmh.code = NTNWM_REALIGN;
 
                 SendMessage(hWndNotify,
@@ -1497,10 +1497,10 @@
 
     BOOL GetClockRect(OUT PRECT rcClock)
     {
-        if (!IsWindowVisible(m_clock->m_hWnd))
+        if (!m_clock->IsWindowVisible())
             return FALSE;
 
-        return GetWindowRect(m_clock->m_hWnd, rcClock);
+        return GetWindowRect(rcClock);
     }
 
     LRESULT OnGetMinimumSize(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
Index: base/shell/explorer/traywnd.cpp
===================================================================
--- base/shell/explorer/traywnd.cpp	(Revision 68346)
+++ base/shell/explorer/traywnd.cpp	(Arbeitskopie)
@@ -218,7 +218,7 @@
                                        SmallIcon.cy,
                                        LR_SHARED | LR_DEFAULTCOLOR);
 
-        hDCScreen = GetDC(NULL);
+        hDCScreen = ::GetDC(NULL);
         if (hDCScreen == NULL)
             goto Cleanup;
 
@@ -282,7 +282,7 @@
 Cleanup:
         if (hDCScreen != NULL)
         {
-            ReleaseDC(NULL, hDCScreen);
+            ::ReleaseDC(NULL, hDCScreen);
         }
 
         if (hbmp != NULL)
@@ -882,7 +882,7 @@
             m_TrayRects[m_Position] = rcTray;
             goto ChangePos;
         }
-        else if (GetWindowRect(m_hWnd, &rcTray))
+        else if (GetWindowRect(&rcTray))
         {
             if (InSizeMove)
             {
@@ -952,7 +952,7 @@
         RECT rcClip, rcWindow;
         HRGN hClipRgn;
 
-        if (GetWindowRect(m_hWnd, &rcWindow))
+        if (GetWindowRect(&rcWindow))
         {
             /* Disable clipping on systems with only one monitor */
             if (GetSystemMetrics(SM_CMONITORS) <= 1)
@@ -980,7 +980,7 @@
 
             /* Set the clipping region or make sure the window isn't clipped
                by disabling it explicitly. */
-            SetWindowRgn(m_hWnd, hClipRgn, TRUE);
+            SetWindowRgn(hClipRgn, TRUE);
         }
     }
 
@@ -1202,7 +1202,7 @@
             /* Get the client rectangle and map it to screen coordinates */
             if (::GetClientRect(hwndExclude,
                 &tmp.rcExclude) &&
-                MapWindowPoints(hwndExclude,
+                ::MapWindowPoints(hwndExclude,
                 NULL,
                 (LPPOINT) &tmp.rcExclude,
                 2) != 0)
@@ -1215,7 +1215,7 @@
         {
             if (ptmp == NULL &&
                 GetClientRect(&tmp.rcExclude) &&
-                MapWindowPoints(m_hWnd,
+                MapWindowPoints(
                 NULL,
                 (LPPOINT) &tmp.rcExclude,
                 2) != 0)
@@ -1344,14 +1344,13 @@
         if (m_StartButton.m_hWnd != NULL)
         {
             /* Resize and reposition the button */
-            dwp = DeferWindowPos(dwp,
-                                 m_StartButton.m_hWnd,
-                                 NULL,
-                                 0,
-                                 0,
-                                 StartSize.cx,
-                                 StartSize.cy,
-                                 SWP_NOZORDER | SWP_NOACTIVATE);
+            dwp = m_StartButton.DeferWindowPos(dwp,
+                                               NULL,
+                                               0,
+                                               0,
+                                               StartSize.cx,
+                                               StartSize.cy,
+                                               SWP_NOZORDER | SWP_NOACTIVATE);
             if (dwp == NULL)
             {
                 ERR("DeferWindowPos for start button failed. lastErr=%d\n", GetLastError());
@@ -1383,14 +1382,14 @@
             else
                 ptTrayNotify.y = rcClient.bottom - TraySize.cy;
 
-            dwp = DeferWindowPos(dwp,
-                                 m_TrayNotify,
-                                 NULL,
-                                 ptTrayNotify.x,
-                                 ptTrayNotify.y,
-                                 TraySize.cx,
-                                 TraySize.cy,
-                                 SWP_NOZORDER | SWP_NOACTIVATE);
+            dwp = ::DeferWindowPos(dwp,
+                                   m_TrayNotify,
+                                   NULL,
+                                   ptTrayNotify.x,
+                                   ptTrayNotify.y,
+                                   TraySize.cx,
+                                   TraySize.cy,
+                                   SWP_NOZORDER | SWP_NOACTIVATE);
             if (dwp == NULL)
             {
                 ERR("DeferWindowPos for notification area failed. lastErr=%d\n", GetLastError());
@@ -1419,14 +1418,14 @@
                 szRebar.cy = ptTrayNotify.y - ptRebar.y;
             }
 
-            dwp = DeferWindowPos(dwp,
-                                 m_Rebar,
-                                 NULL,
-                                 ptRebar.x,
-                                 ptRebar.y,
-                                 szRebar.cx,
-                                 szRebar.cy,
-                                 SWP_NOZORDER | SWP_NOACTIVATE);
+            dwp = ::DeferWindowPos(dwp,
+                                   m_Rebar,
+                                   NULL,
+                                   ptRebar.x,
+                                   ptRebar.y,
+                                   szRebar.cx,
+                                   szRebar.cy,
+                                   SWP_NOZORDER | SWP_NOACTIVATE);
         }
 
         if (dwp != NULL)
@@ -1586,7 +1585,7 @@
            If it was somehow destroyed just create a new tray window. */
         if (m_hWnd != NULL && IsWindow())
         {
-            if (!IsWindowVisible(m_hWnd))
+            if (!IsWindowVisible())
             {
                 CheckTrayWndPosition();
 
@@ -1656,7 +1655,7 @@
         HWND hwnd;
         RECT posRect;
 
-        GetWindowRect(m_StartButton.m_hWnd, &posRect);
+        m_StartButton.GetWindowRect(&posRect);
         hwnd = CreateWindowEx(0,
                               WC_STATIC,
                               NULL,
@@ -1693,7 +1692,7 @@
 
         if (m_TrayPropertiesOwner)
         {
-            hTrayProp = GetLastActivePopup(m_TrayPropertiesOwner);
+            hTrayProp = ::GetLastActivePopup(m_TrayPropertiesOwner);
             if (hTrayProp != NULL &&
                 hTrayProp != m_TrayPropertiesOwner)
             {
@@ -1886,10 +1885,10 @@
         RECT rect;
         int backoundPart;
 
-        GetWindowRect(m_hWnd, &rect);
+        GetWindowRect(&rect);
         OffsetRect(&rect, -rect.left, -rect.top);
 
-        hdc = GetDCEx(m_hWnd, hRgn, DCX_WINDOW | DCX_INTERSECTRGN | DCX_PARENTCLIP);
+        hdc = GetDCEx(hRgn, DCX_WINDOW | DCX_INTERSECTRGN | DCX_PARENTCLIP);
 
         switch (m_Position)
         {
@@ -1917,7 +1916,7 @@
         }
         DrawThemeBackground(m_Theme, hdc, backoundPart, 0, &rect, 0);
 
-        ReleaseDC(m_hWnd, hdc);
+        ReleaseDC(hdc);
         return 0;
     }
 
@@ -1926,7 +1925,7 @@
         HWND hwnd;
         RECT posRect;
 
-        GetWindowRect(m_StartButton.m_hWnd, &posRect);
+        m_StartButton.GetWindowRect(&posRect);
 
         hwnd = CreateWindowEx(0,
                               WC_STATIC,
@@ -1962,7 +1961,7 @@
         HWND hRunDlg;
         if (m_RunFileDlgOwner)
         {
-            hRunDlg = GetLastActivePopup(m_RunFileDlgOwner);
+            hRunDlg = ::GetLastActivePopup(m_RunFileDlgOwner);
             if (hRunDlg != NULL &&
                 hRunDlg != m_RunFileDlgOwner)
             {
@@ -1982,7 +1981,7 @@
             RECTL rcExclude;
             DWORD dwFlags = 0;
 
-            if (GetWindowRect(m_StartButton.m_hWnd, (RECT*) &rcExclude))
+            if (m_StartButton.GetWindowRect((RECT*) &rcExclude))
             {
                 switch (m_Position)
                 {
@@ -2023,7 +2022,7 @@
         UINT state = m_AutoHideState;
 
         GetCursorPos(&pt);
-        GetWindowRect(m_hWnd, &rcCurrent);
+        GetWindowRect(&rcCurrent);
         over = PtInRect(&rcCurrent, pt);
 
         if (m_StartButton.SendMessage( BM_GETSTATE, 0, 0) != BST_UNCHECKED)
@@ -2243,7 +2242,7 @@
 
         SetLastError(ERROR_SUCCESS);
         if (GetClientRect(&rcClient) &&
-            (MapWindowPoints(m_hWnd, NULL, (LPPOINT) &rcClient, 2) != 0 || GetLastError() == ERROR_SUCCESS))
+            (MapWindowPoints(NULL, (LPPOINT) &rcClient, 2) != 0 || GetLastError() == ERROR_SUCCESS))
         {
             pt.x = (SHORT) LOWORD(lParam);
             pt.y = (SHORT) HIWORD(lParam);
@@ -2386,7 +2385,7 @@
         if (!Locked)
         {
             /* Apply clipping */
-            PostMessage(m_hWnd, WM_SIZE, SIZE_RESTORED, 0);
+            PostMessage(WM_SIZE, SIZE_RESTORED, 0);
         }
         return TRUE;
     }
@@ -2415,7 +2414,7 @@
             /* temporarily enable the system menu */
             SetWindowStyle(m_hWnd, WS_SYSMENU, WS_SYSMENU);
 
-            hSysMenu = GetSystemMenu(m_hWnd, FALSE);
+            hSysMenu = GetSystemMenu(FALSE);
             if (hSysMenu != NULL)
             {
                 /* Disable all items that are not relevant */
@@ -2503,17 +2502,17 @@
                 POINT ptClient = *ppt;
 
                 /* Convert the coordinates to client-coordinates */
-                MapWindowPoints(NULL, m_hWnd, &ptClient, 1);
+                ::MapWindowPoints(NULL, m_hWnd, &ptClient, 1);
 
-                hWndAtPt = ChildWindowFromPoint(m_hWnd, ptClient);
+                hWndAtPt = ChildWindowFromPoint(ptClient);
                 if (hWndAtPt != NULL &&
-                    (hWndAtPt == m_Rebar || IsChild(m_Rebar, hWndAtPt)))
+                    (hWndAtPt == m_Rebar || ::IsChild(m_Rebar, hWndAtPt)))
                 {
                     /* Check if the user clicked on the task switch window */
                     ptClient = *ppt;
-                    MapWindowPoints(NULL, m_Rebar, &ptClient, 1);
+                    ::MapWindowPoints(NULL, m_Rebar, &ptClient, 1);
 
-                    hWndAtPt = ChildWindowFromPointEx(m_Rebar, ptClient, CWP_SKIPINVISIBLE | CWP_SKIPDISABLED);
+                    hWndAtPt = ::ChildWindowFromPointEx(m_Rebar, ptClient, CWP_SKIPINVISIBLE | CWP_SKIPDISABLED);
                     if (hWndAtPt == m_TaskSwitch)
                         goto HandleTrayContextMenu;
 
@@ -2561,7 +2560,7 @@
                 {
                 case NTNWM_REALIGN:
                     /* Cause all controls to be aligned */
-                    PostMessage(m_hWnd, WM_SIZE, SIZE_RESTORED, 0);
+                    PostMessage(WM_SIZE, SIZE_RESTORED, 0);
                     break;
                 }
             }
@@ -2604,7 +2603,7 @@
         if (FAILED_UNEXPECTEDLY(hr))
             return FALSE;
 
-        if (IsWindowVisible(hwndStartMenu))
+        if (::IsWindowVisible(hwndStartMenu))
         {
             m_StartMenuPopup->OnSelect(MPOS_CANCELLEVEL);
         }
Index: base/shell/rshell/CMenuDeskBar.cpp
===================================================================
--- base/shell/rshell/CMenuDeskBar.cpp	(Revision 68346)
+++ base/shell/rshell/CMenuDeskBar.cpp	(Arbeitskopie)
@@ -371,7 +371,7 @@
     }
 
     RECT rcWorkArea;
-    GetWindowRect(GetDesktopWindow(), &rcWorkArea);
+    ::GetWindowRect(GetDesktopWindow(), &rcWorkArea);
     int cxWorkArea = rcWorkArea.right - rcWorkArea.left;
     int cyWorkArea = rcWorkArea.bottom - rcWorkArea.top;
 
Index: base/shell/rshell/CMenuToolbars.cpp
===================================================================
--- base/shell/rshell/CMenuToolbars.cpp	(Revision 68346)
+++ base/shell/rshell/CMenuToolbars.cpp	(Arbeitskopie)
@@ -700,8 +700,8 @@
     POINT a = { rc.left, rc.top };
     POINT b = { rc.right, rc.bottom };
 
-    ClientToScreen(m_hWnd, &a);
-    ClientToScreen(m_hWnd, &b);
+    ClientToScreen(&a);
+    ClientToScreen(&b);
 
     POINTL pt = { a.x, b.y };
     RECTL rcl = { a.x, a.y, b.x, b.y };
@@ -741,8 +741,8 @@
     POINT a = { rc.left, rc.top };
     POINT b = { rc.right, rc.bottom };
 
-    ClientToScreen(m_hWnd, &a);
-    ClientToScreen(m_hWnd, &b);
+    ClientToScreen(&a);
+    ClientToScreen(&b);
 
     POINT pt = { a.x, b.y };
     RECT rcl = { a.x, a.y, b.x, b.y };
@@ -937,7 +937,7 @@
                         HWND tlw;
                         m_menuBand->_GetTopLevelWindow(&tlw);
                         SendMessageW(tlw, WM_CANCELMODE, 0, 0);
-                        PostMessageW(m_hWnd, WM_USER_CHANGETRACKEDITEM, index, MAKELPARAM(m_isTrackingPopup, FALSE));
+                        PostMessageW(WM_USER_CHANGETRACKEDITEM, index, MAKELPARAM(m_isTrackingPopup, FALSE));
                     }
                     else
                         m_menuBand->_ChangeHotItem(this, btn.idCommand, 0);
Index: dll/win32/browseui/addresseditbox.cpp
===================================================================
--- dll/win32/browseui/addresseditbox.cpp	(Revision 68346)
+++ dll/win32/browseui/addresseditbox.cpp	(Arbeitskopie)
@@ -108,10 +108,10 @@
         return hr;
 
     LPWSTR input;
-    int inputLength = GetWindowTextLength(fCombobox.m_hWnd) + 2;
+    int inputLength = fCombobox.GetWindowTextLength() + 2;
 
     input = new WCHAR[inputLength];
-    GetWindowText(fCombobox.m_hWnd, input, inputLength);
+    fCombobox.GetWindowText(input, inputLength);
 
     LPWSTR address;
     int addressLength = ExpandEnvironmentStrings(input, NULL, 0);
Index: dll/win32/browseui/internettoolbar.cpp
===================================================================
--- dll/win32/browseui/internettoolbar.cpp	(Revision 68346)
+++ dll/win32/browseui/internettoolbar.cpp	(Arbeitskopie)
@@ -974,7 +974,7 @@
 
     // RBSTR_CHANGERECT does not seem to set the proper size in the rect.
     // Let's make sure we fetch the actual size properly.
-    GetWindowRect(fMainReBar, &availableBorderSpace);
+    ::GetWindowRect(fMainReBar, &availableBorderSpace);
     neededBorderSpace.left = 0;
     neededBorderSpace.top = availableBorderSpace.bottom - availableBorderSpace.top;
     if (!fLocked)
@@ -1841,7 +1841,7 @@
     fStartPosition.y = GET_Y_LPARAM(msgp);
     
     RECT rc;
-    GetWindowRect(m_hWnd, &rc);
+    GetWindowRect(&rc);
 
     fStartHeight = rc.bottom - rc.top;
 
Index: dll/win32/browseui/shellbrowser.cpp
===================================================================
--- dll/win32/browseui/shellbrowser.cpp	(Revision 68346)
+++ dll/win32/browseui/shellbrowser.cpp	(Arbeitskopie)
@@ -1306,10 +1306,10 @@
     {
         if (uMsg == WM_NCDESTROY)
         {
-            saveWindowProc = reinterpret_cast<WNDPROC>(GetWindowLongPtr(hWnd, GWL_WNDPROC));
+            saveWindowProc = reinterpret_cast<WNDPROC>(::GetWindowLongPtr(hWnd, GWL_WNDPROC));
             lResult = pThis->DefWindowProc(uMsg, wParam, lParam);
-            if (saveWindowProc == reinterpret_cast<WNDPROC>(GetWindowLongPtr(hWnd, GWL_WNDPROC)))
-                SetWindowLongPtr(hWnd, GWL_WNDPROC, (LONG_PTR)pThis->m_pfnSuperWindowProc);
+            if (saveWindowProc == reinterpret_cast<WNDPROC>(::GetWindowLongPtr(hWnd, GWL_WNDPROC)))
+                ::SetWindowLongPtr(hWnd, GWL_WNDPROC, (LONG_PTR)pThis->m_pfnSuperWindowProc);
             pThis->m_dwState |= WINSTATE_DESTROYED;
         }
         else