Index: dll/keyboard/kbdarmw/kbdarmw.c
===================================================================
--- dll/keyboard/kbdarmw/kbdarmw.c	(revision 68754)
+++ dll/keyboard/kbdarmw/kbdarmw.c	(working copy)
@@ -356,3 +356,15 @@
 PKBDTABLES WINAPI KbdLayerDescriptor(VOID) {
   return &keyboard_layout_table;
 }
+
+INT WINAPI
+DllMain(
+ PVOID hinstDll,
+ ULONG dwReason,
+ PVOID reserved)
+{
+ return 1;
+}
+
+/* E.O.F */
+
Index: dll/keyboard/kbdes/kbdes.c
===================================================================
--- dll/keyboard/kbdes/kbdes.c	(revision 68754)
+++ dll/keyboard/kbdes/kbdes.c	(working copy)
@@ -551,3 +551,14 @@
 {
   return &keyboard_layout_table;
 }
+
+INT WINAPI
+DllMain( 
+ PVOID hinstDll,
+ ULONG dwReason, 
+ PVOID Reserved)
+{
+ return 1;
+}
+
+/* E.O.F */
Index: dll/keyboard/kbduk/kbduk.c
===================================================================
--- dll/keyboard/kbduk/kbduk.c	(revision 68754)
+++ dll/keyboard/kbduk/kbduk.c	(working copy)
@@ -399,3 +399,14 @@
   return &keyboard_layout_table;
 }
 
+INT WINAPI
+DllMain(
+ PVOID hinstDll,
+ ULONG dwReason,
+ PVOID reserved)
+{
+ return 1;
+}
+
+/* E.O.F */
+
Index: dll/keyboard/kbdgerg/kbdgerg.c
===================================================================
--- dll/keyboard/kbdgerg/kbdgerg.c	(revision 68754)
+++ dll/keyboard/kbdgerg/kbdgerg.c	(working copy)
@@ -446,3 +446,14 @@
   return &keyboard_layout_table;
 }
 
+INT WINAPI
+DllMain(
+ PVOID hinstDll,
+ ULONG dwReason,
+ PVOID reserved)
+{
+ return 1;
+}
+
+/* E.O.F */
+
Index: dll/keyboard/kbdus/kbdus.c
===================================================================
--- dll/keyboard/kbdus/kbdus.c	(revision 68754)
+++ dll/keyboard/kbdus/kbdus.c	(working copy)
@@ -394,3 +394,14 @@
   return &keyboard_layout_table;
 }
 
+INT WINAPI
+DllMain(
+ PVOID hinstDll,
+ ULONG dwReason,
+ PVOID reserved)
+{
+ return 1;
+}
+
+/* E.O.F */
+
Index: dll/keyboard/kbdja/kbdja.c
===================================================================
--- dll/keyboard/kbdja/kbdja.c	(revision 68754)
+++ dll/keyboard/kbdja/kbdja.c	(working copy)
@@ -401,3 +401,14 @@
   return &keyboard_layout_table;
 }
 
+INT WINAPI
+DllMain(
+ PVOID hinstDll,
+ ULONG dwReason,
+ PVOID reserved)
+{
+ return 1;
+}
+
+/* E.O.F */
+
Index: dll/keyboard/kbdsk1/kbdsk1.c
===================================================================
--- dll/keyboard/kbdsk1/kbdsk1.c	(revision 68754)
+++ dll/keyboard/kbdsk1/kbdsk1.c	(working copy)
@@ -460,3 +460,15 @@
 PKBDTABLES WINAPI KbdLayerDescriptor(VOID) {
   return &keyboard_layout_table;
 }
+
+INT WINAPI
+DllMain(
+ PVOID hinstDll,
+ ULONG dwReason,
+ PVOID reserved)
+{
+ return 1;
+}
+
+/* E.O.F */
+
Index: dll/keyboard/kbdfi/kbdfi.c
===================================================================
--- dll/keyboard/kbdfi/kbdfi.c	(revision 68754)
+++ dll/keyboard/kbdfi/kbdfi.c	(working copy)
@@ -466,3 +466,15 @@
 PKBDTABLES WINAPI KbdLayerDescriptor(VOID) {
   return &keyboard_layout_table;
 }
+
+INT WINAPI
+DllMain(
+ PVOID hinstDll,
+ ULONG dwReason,
+ PVOID reserved)
+{
+ return 1;
+}
+
+/* E.O.F */
+
Index: dll/keyboard/kbdfr/kbdfr.c
===================================================================
--- dll/keyboard/kbdfr/kbdfr.c	(revision 68754)
+++ dll/keyboard/kbdfr/kbdfr.c	(working copy)
@@ -467,3 +467,14 @@
   return &keyboard_layout_table;
 }
 
+INT WINAPI
+DllMain(
+ PVOID hinstDll,
+ ULONG dwReason,
+ PVOID reserved)
+{
+ return 1;
+}
+
+/* E.O.F */
+
Index: dll/keyboard/kbdgrist/kbdgrist.c
===================================================================
--- dll/keyboard/kbdgrist/kbdgrist.c	(revision 68754)
+++ dll/keyboard/kbdgrist/kbdgrist.c	(working copy)
@@ -446,3 +446,14 @@
   return &keyboard_layout_table;
 }
 
+INT WINAPI
+DllMain(
+ PVOID hinstDll,
+ ULONG dwReason,
+ PVOID reserved)
+{
+ return 1;
+}
+
+/* E.O.F */
+
Index: dll/keyboard/kbdgneo/kbdgneo.c
===================================================================
--- dll/keyboard/kbdgneo/kbdgneo.c	(revision 68754)
+++ dll/keyboard/kbdgneo/kbdgneo.c	(working copy)
@@ -446,3 +446,14 @@
   return &keyboard_layout_table;
 }
 
+INT WINAPI
+DllMain(
+ PVOID hinstDll,
+ ULONG dwReason,
+ PVOID reserved)
+{
+ return 1;
+}
+
+/* E.O.F */
+
Index: dll/keyboard/kbdheb/kbdheb.c
===================================================================
--- dll/keyboard/kbdheb/kbdheb.c	(revision 68754)
+++ dll/keyboard/kbdheb/kbdheb.c	(working copy)
@@ -511,3 +511,14 @@
   return &keyboard_layout_table;
 }
 
+INT WINAPI
+DllMain(
+ PVOID hinstDll,
+ ULONG dwReason,
+ PVOID reserved)
+{
+ return 1;
+}
+
+/* E.O.F */
+
Index: dll/keyboard/kbda1/kbda1.c
===================================================================
--- dll/keyboard/kbda1/kbda1.c	(revision 68754)
+++ dll/keyboard/kbda1/kbda1.c	(working copy)
@@ -381,3 +381,16 @@
 PKBDTABLES WINAPI KbdLayerDescriptor(VOID) {
   return &keyboard_layout_table;
 }
+
+INT WINAPI
+DllMain(
+
+ PVOID hinstDll,
+ ULONG dwReason,
+ PVOID reserved)
+
+{
+ return 1;
+}
+
+/* E.O.F  */
Index: dll/keyboard/kbda2/kbda2.c
===================================================================
--- dll/keyboard/kbda2/kbda2.c	(revision 68754)
+++ dll/keyboard/kbda2/kbda2.c	(working copy)
@@ -398,3 +398,16 @@
 PKBDTABLES WINAPI KbdLayerDescriptor(VOID) {
   return &keyboard_layout_table;
 }
+
+INT WINAPI
+DllMain(
+
+ PVOID hinstDll,
+ ULONG dwReason,
+ PVOID reserved)
+
+{
+ return 1;
+}
+
+/* E.O.F */
Index: dll/keyboard/kbda3/kbda3.c
===================================================================
--- dll/keyboard/kbda3/kbda3.c	(revision 68754)
+++ dll/keyboard/kbda3/kbda3.c	(working copy)
@@ -398,3 +398,14 @@
 PKBDTABLES WINAPI KbdLayerDescriptor(VOID) {
   return &keyboard_layout_table;
 }
+
+INT WINAPI
+DllMain(
+ PVOID hinstDll,
+ ULONG dwReason,
+ PVOID reserved)
+{
+ return 1;
+}
+
+/* E.O.F */
Index: dll/keyboard/kbdgr/kbdgr.c
===================================================================
--- dll/keyboard/kbdgr/kbdgr.c	(revision 68754)
+++ dll/keyboard/kbdgr/kbdgr.c	(working copy)
@@ -446,3 +446,14 @@
   return &keyboard_layout_table;
 }
 
+INT WINAPI
+DllMain(
+ PVOID hinstDll,
+ ULONG dwReason,
+ PVOID reserved)
+{
+ return 1;
+}
+
+/* E.O.F */
+
Index: dll/keyboard/kbdko/kbdko.c
===================================================================
--- dll/keyboard/kbdko/kbdko.c	(revision 68754)
+++ dll/keyboard/kbdko/kbdko.c	(working copy)
@@ -393,3 +393,14 @@
   return &keyboard_layout_table;
 }
 
+INT WINAPI
+DllMain(
+ PVOID hinstDll,
+ ULONG dwReason,
+ PVOID reserved)
+{
+ return 1;
+}
+
+/* E.O.F */
+
Index: dll/keyboard/kbdsg/kbdsg.c
===================================================================
--- dll/keyboard/kbdsg/kbdsg.c	(revision 68754)
+++ dll/keyboard/kbdsg/kbdsg.c	(working copy)
@@ -474,3 +474,14 @@
   return &keyboard_layout_table;
 }
 
+INT WINAPI
+DllMain(
+ PVOID hinstDll,
+ ULONG dwReason,
+ PVOID reserved)
+{
+ return 1;
+}
+
+/* E.O.F */
+
Index: dll/keyboard/kbdcz/kbdcz.c
===================================================================
--- dll/keyboard/kbdcz/kbdcz.c	(revision 68754)
+++ dll/keyboard/kbdcz/kbdcz.c	(working copy)
@@ -473,3 +473,15 @@
 PKBDTABLES WINAPI KbdLayerDescriptor(VOID) {
   return &keyboard_layout_table;
 }
+
+INT WINAPI
+DllMain(
+ PVOID hinstDll,
+ ULONG dwReason,
+ PVOID reserved)
+{
+ return 1;
+}
+
+/* E.O.F */
+
Index: dll/keyboard/kbdsk/kbdsk.c
===================================================================
--- dll/keyboard/kbdsk/kbdsk.c	(revision 68754)
+++ dll/keyboard/kbdsk/kbdsk.c	(working copy)
@@ -461,3 +461,14 @@
   return &keyboard_layout_table;
 }
 
+INT WINAPI
+DllMain(
+ PVOID hinstDll,
+ ULONG dwReason,
+ PVOID reserved)
+{
+ return 1;
+}
+
+/* E.O.F */
+
Index: dll/keyboard/kbdbur/kbdbur.c
===================================================================
--- dll/keyboard/kbdbur/kbdbur.c	(revision 68754)
+++ dll/keyboard/kbdbur/kbdbur.c	(working copy)
@@ -376,4 +376,13 @@
   return &keyboard_layout_table;
 }
 
+INT WINAPI
+DllMain(
+ PVOID hinstDll,
+ ULONG dwReason,
+ PVOID reserved)
+{
+ return 1;
+}
+
 /* EOF */
Index: dll/keyboard/kbdest/kbdest.c
===================================================================
--- dll/keyboard/kbdest/kbdest.c	(revision 68754)
+++ dll/keyboard/kbdest/kbdest.c	(working copy)
@@ -388,3 +388,14 @@
   return &keyboard_layout_table;
 }
 
+INT WINAPI
+DllMain(
+ PVOID hinstDll,
+ ULONG dwReason,
+ PVOID reserved)
+{
+ return 1;
+}
+
+/* E.O.F */
+
Index: dll/keyboard/kbdhe/kbdhe.c
===================================================================
--- dll/keyboard/kbdhe/kbdhe.c	(revision 68754)
+++ dll/keyboard/kbdhe/kbdhe.c	(working copy)
@@ -417,3 +417,15 @@
 PKBDTABLES WINAPI KbdLayerDescriptor(VOID) {
   return &keyboard_layout_table;
 }
+
+INT WINAPI
+DllMain(
+ PVOID hinstDll,
+ ULONG dwReason,
+ PVOID reserved)
+{
+ return 1;
+}
+
+/* E.O.F */
+
Index: dll/keyboard/kbddv/kbddv.c
===================================================================
--- dll/keyboard/kbddv/kbddv.c	(revision 68754)
+++ dll/keyboard/kbddv/kbddv.c	(working copy)
@@ -387,3 +387,14 @@
   return &keyboard_layout_table;
 }
 
+INT WINAPI
+DllMain(
+ PVOID hinstDll,
+ ULONG dwReason,
+ PVOID reserved)
+{
+ return 1;
+}
+
+/* E.O.F */
+
Index: dll/keyboard/kbdpl/kbdpl.c
===================================================================
--- dll/keyboard/kbdpl/kbdpl.c	(revision 68754)
+++ dll/keyboard/kbdpl/kbdpl.c	(working copy)
@@ -412,3 +412,14 @@
   return &keyboard_layout_table;
 }
 
+INT WINAPI
+DllMain(
+ PVOID hinstDll,
+ ULONG dwReason,
+ PVOID reserved)
+{
+ return 1;
+}
+
+/* E.O.F */
+
Index: dll/keyboard/kbdhu/kbdhu.c
===================================================================
--- dll/keyboard/kbdhu/kbdhu.c	(revision 68754)
+++ dll/keyboard/kbdhu/kbdhu.c	(working copy)
@@ -387,3 +387,14 @@
   return &keyboard_layout_table;
 }
 
+INT WINAPI
+DllMain(
+ PVOID hinstDll,
+ ULONG dwReason,
+ PVOID reserved)
+{
+ return 1;
+}
+
+/* E.O.F */
+
Index: dll/keyboard/kbdpo/kbdpo.c
===================================================================
--- dll/keyboard/kbdpo/kbdpo.c	(revision 68754)
+++ dll/keyboard/kbdpo/kbdpo.c	(working copy)
@@ -569,3 +569,15 @@
 PKBDTABLES WINAPI KbdLayerDescriptor(VOID) {
   return &keyboard_layout_table;
 }
+
+INT WINAPI
+DllMain(
+ PVOID hinstDll,
+ ULONG dwReason,
+ PVOID reserved)
+{
+ return 1;
+}
+
+/* E.O.F */
+
Index: dll/keyboard/kbdlv/kbdlv.c
===================================================================
--- dll/keyboard/kbdlv/kbdlv.c	(revision 68754)
+++ dll/keyboard/kbdlv/kbdlv.c	(working copy)
@@ -389,3 +389,14 @@
   return &keyboard_layout_table;
 }
 
+INT WINAPI
+DllMain(
+ PVOID hinstDll,
+ ULONG dwReason,
+ PVOID reserved)
+{
+ return 1;
+}
+
+/* E.O.F */
+
Index: dll/keyboard/kbdarme/kbdarme.c
===================================================================
--- dll/keyboard/kbdarme/kbdarme.c	(revision 68754)
+++ dll/keyboard/kbdarme/kbdarme.c	(working copy)
@@ -368,3 +368,15 @@
 PKBDTABLES WINAPI KbdLayerDescriptor(VOID) {
   return &keyboard_layout_table;
 }
+
+INT WINAPI
+DllMain(
+ PVOID hinstDll,
+ ULONG dwReason,
+ PVOID reserved)
+{
+ return 1;
+}
+
+/* E.O.F */
+
Index: dll/keyboard/kbdbga/kbdbga.c
===================================================================
--- dll/keyboard/kbdbga/kbdbga.c	(revision 68754)
+++ dll/keyboard/kbdbga/kbdbga.c	(working copy)
@@ -396,3 +396,15 @@
 PKBDTABLES WINAPI KbdLayerDescriptor(VOID) {
   return &keyboard_layout_table;
 }
+
+INT WINAPI
+DllMain(
+ PVOID hinstDll,
+ ULONG dwReason,
+ PVOID reserved)
+{
+ return 1;
+}
+
+/* E.O.F */
+
Index: dll/keyboard/kbdth0/kbdth0.c
===================================================================
--- dll/keyboard/kbdth0/kbdth0.c	(revision 68754)
+++ dll/keyboard/kbdth0/kbdth0.c	(working copy)
@@ -373,3 +373,15 @@
 PKBDTABLES WINAPI KbdLayerDescriptor(VOID) {
   return &keyboard_layout_table;
 }
+
+INT WINAPI
+DllMain(
+ PVOID hinstDll,
+ ULONG dwReason,
+ PVOID reserved)
+{
+ return 1;
+}
+
+/* E.O.F */
+
Index: dll/keyboard/kbdth1/kbdth1.c
===================================================================
--- dll/keyboard/kbdth1/kbdth1.c	(revision 68754)
+++ dll/keyboard/kbdth1/kbdth1.c	(working copy)
@@ -373,3 +373,15 @@
 PKBDTABLES WINAPI KbdLayerDescriptor(VOID) {
   return &keyboard_layout_table;
 }
+
+INT WINAPI
+DllMain(
+ PVOID hinstDll,
+ ULONG dwReason,
+ PVOID reserved)
+{
+ return 1;
+}
+
+/* E.O.F */
+
Index: dll/keyboard/kbdpl1/kbdpl1.c
===================================================================
--- dll/keyboard/kbdpl1/kbdpl1.c	(revision 68754)
+++ dll/keyboard/kbdpl1/kbdpl1.c	(working copy)
@@ -428,3 +428,14 @@
   return &keyboard_layout_table;
 }
 
+INT WINAPI
+DllMain(
+ PVOID hinstDll,
+ ULONG dwReason,
+ PVOID reserved)
+{
+ return 1;
+}
+
+/* E.O.F */
+
Index: dll/keyboard/kbdth2/kbdth2.c
===================================================================
--- dll/keyboard/kbdth2/kbdth2.c	(revision 68754)
+++ dll/keyboard/kbdth2/kbdth2.c	(working copy)
@@ -375,4 +375,13 @@
   return &keyboard_layout_table;
 }
 
+INT WINAPI
+DllMain(
+ PVOID hinstDll,
+ ULONG dwReason,
+ PVOID reserved)
+{
+ return 1;
+}
+
 /* EOF */
Index: dll/keyboard/kbdcz1/kbdcz1.c
===================================================================
--- dll/keyboard/kbdcz1/kbdcz1.c	(revision 68754)
+++ dll/keyboard/kbdcz1/kbdcz1.c	(working copy)
@@ -466,3 +466,15 @@
 PKBDTABLES WINAPI KbdLayerDescriptor(VOID) {
   return &keyboard_layout_table;
 }
+
+INT WINAPI
+DllMain(
+ PVOID hinstDll,
+ ULONG dwReason,
+ PVOID reserved)
+{
+ return 1;
+}
+
+/* E.O.F */
+
Index: dll/keyboard/kbdth3/kbdth3.c
===================================================================
--- dll/keyboard/kbdth3/kbdth3.c	(revision 68754)
+++ dll/keyboard/kbdth3/kbdth3.c	(working copy)
@@ -373,3 +373,15 @@
 PKBDTABLES WINAPI KbdLayerDescriptor(VOID) {
   return &keyboard_layout_table;
 }
+
+INT WINAPI
+DllMain(
+ PVOID hinstDll,
+ ULONG dwReason,
+ PVOID reserved)
+{
+ return 1;
+}
+
+/* E.O.F */
+
Index: dll/keyboard/kbdlt1/kbdlt1.c
===================================================================
--- dll/keyboard/kbdlt1/kbdlt1.c	(revision 68754)
+++ dll/keyboard/kbdlt1/kbdlt1.c	(working copy)
@@ -384,3 +384,15 @@
 PKBDTABLES WINAPI KbdLayerDescriptor(VOID) {
   return &keyboard_layout_table;
 }
+
+INT WINAPI
+DllMain(
+ PVOID hinstDll,
+ ULONG dwReason,
+ PVOID reserved)
+{
+ return 1;
+}
+
+/* E.O.F */
+