Index: dll/win32/schannel/schannel_mbedtls_lazyload.h
===================================================================
--- dll/win32/schannel/schannel_mbedtls_lazyload.h	(revisión: 69455)
+++ dll/win32/schannel/schannel_mbedtls_lazyload.h	(copia de trabajo)
@@ -137,35 +137,35 @@
 
 /* seamlessly redirect the function pointers with some preprocessor magic */
 
-#define mbedtls_ctr_drbg_free           mbedtls_ctr_drbg_free
-#define mbedtls_ctr_drbg_init           mbedtls_ctr_drbg_init
-#define mbedtls_ctr_drbg_random         mbedtls_ctr_drbg_random
-#define mbedtls_entropy_free            mbedtls_entropy_free
-#define mbedtls_entropy_func            mbedtls_entropy_func
-#define mbedtls_entropy_init            mbedtls_entropy_init
-#define mbedtls_ssl_ciphersuite_from_id mbedtls_ssl_ciphersuite_from_id
-#define mbedtls_ssl_free                mbedtls_ssl_free
-#define mbedtls_ssl_get_ciphersuite     mbedtls_ssl_get_ciphersuite
-#define mbedtls_ssl_get_ciphersuite_id  mbedtls_ssl_get_ciphersuite_id
-#define mbedtls_ssl_get_max_frag_len    mbedtls_ssl_get_max_frag_len
-#define mbedtls_ssl_get_version         mbedtls_ssl_get_version
-#define mbedtls_ssl_handshake           mbedtls_ssl_handshake
-#define mbedtls_ssl_init                mbedtls_ssl_init
-#define mbedtls_ssl_read                mbedtls_ssl_read
-#define mbedtls_ssl_conf_authmode       mbedtls_ssl_conf_authmode 
-#define mbedtls_ssl_set_bio             mbedtls_ssl_set_bio
-#define mbedtls_ssl_conf_endpoint       mbedtls_ssl_conf_endpoint
-#define mbedtls_ssl_set_hostname        mbedtls_ssl_set_hostname
-#define mbedtls_ssl_conf_max_version    mbedtls_ssl_conf_max_version
-#define mbedtls_ssl_conf_min_version    mbedtls_ssl_conf_min_version
-#define mbedtls_ssl_conf_rng            mbedtls_ssl_conf_rng
-#define mbedtls_ssl_write               mbedtls_ssl_write
-#define mbedtls_ssl_get_peer_cert       mbedtls_ssl_get_peer_cert
-#define mbedtls_ssl_config_init         mbedtls_ssl_config_init
-#define mbedtls_ssl_config_defaults     mbedtls_ssl_config_defaults
-#define mbedtls_ssl_conf_dbg            mbedtls_ssl_conf_dbg
-#define mbedtls_ssl_setup               mbedtls_ssl_setup
-#define mbedtls_cipher_info_from_type   mbedtls_cipher_info_from_type      
-#define mbedtls_md_info_from_type       mbedtls_md_info_from_type
-#define mbedtls_pk_get_bitlen           mbedtls_pk_get_bitlen
-#define mbedtls_ctr_drbg_seed           mbedtls_ctr_drbg_seed
\ No newline at end of file
+#define mbedtls_ctr_drbg_free           pmbedtls_ctr_drbg_free
+#define mbedtls_ctr_drbg_init           pmbedtls_ctr_drbg_init
+#define mbedtls_ctr_drbg_random         pmbedtls_ctr_drbg_random
+#define mbedtls_entropy_free            pmbedtls_entropy_free
+#define mbedtls_entropy_func            pmbedtls_entropy_func
+#define mbedtls_entropy_init            pmbedtls_entropy_init
+#define mbedtls_ssl_ciphersuite_from_id pmbedtls_ssl_ciphersuite_from_id
+#define mbedtls_ssl_free                pmbedtls_ssl_free
+#define mbedtls_ssl_get_ciphersuite     pmbedtls_ssl_get_ciphersuite
+#define mbedtls_ssl_get_ciphersuite_id  pmbedtls_ssl_get_ciphersuite_id
+#define mbedtls_ssl_get_max_frag_len    pmbedtls_ssl_get_max_frag_len
+#define mbedtls_ssl_get_version         pmbedtls_ssl_get_version
+#define mbedtls_ssl_handshake           pmbedtls_ssl_handshake
+#define mbedtls_ssl_init                pmbedtls_ssl_init
+#define mbedtls_ssl_read                pmbedtls_ssl_read
+#define mbedtls_ssl_conf_authmode       pmbedtls_ssl_conf_authmode 
+#define mbedtls_ssl_set_bio             pmbedtls_ssl_set_bio
+#define mbedtls_ssl_conf_endpoint       pmbedtls_ssl_conf_endpoint
+#define mbedtls_ssl_set_hostname        pmbedtls_ssl_set_hostname
+#define mbedtls_ssl_conf_max_version    pmbedtls_ssl_conf_max_version
+#define mbedtls_ssl_conf_min_version    pmbedtls_ssl_conf_min_version
+#define mbedtls_ssl_conf_rng            pmbedtls_ssl_conf_rng
+#define mbedtls_ssl_write               pmbedtls_ssl_write
+#define mbedtls_ssl_get_peer_cert       pmbedtls_ssl_get_peer_cert
+#define mbedtls_ssl_config_init         pmbedtls_ssl_config_init
+#define mbedtls_ssl_config_defaults     pmbedtls_ssl_config_defaults
+#define mbedtls_ssl_conf_dbg            pmbedtls_ssl_conf_dbg
+#define mbedtls_ssl_setup               pmbedtls_ssl_setup
+#define mbedtls_cipher_info_from_type   pmbedtls_cipher_info_from_type      
+#define mbedtls_md_info_from_type       pmbedtls_md_info_from_type
+#define mbedtls_pk_get_bitlen           pmbedtls_pk_get_bitlen
+#define mbedtls_ctr_drbg_seed           pmbedtls_ctr_drbg_seed
\ No newline at end of file